function m=pad(filnm)
% 
% Example calling line: pad b620s.fit will read the desired file, typically
%  a .fit file output by the fitting program or a data file from lp2d
%  with the range -100 to 100 chosen on both axes.  It will expand the 
%  data limits for use as an spc file input to the 2D fitting programs
%  For this purpose, the data must be forced into a range 
%  exceeding -100 to 100.  This will be done by adding an additional
%  line around the data set.  Random noise is added to simulate an 
%  experiment.
% 
%  The data is then written to the file name.spd.
%

randfac=0.01;	% amount of random noise added
fid=fopen(filnm);
if fid == (-1)   ;                      % does file exist?
    error(['stap: Could not open file filename check path and exist? ']);
end;
filnm2=[strtok(filnm,'.') '.spd'];
fid2=fopen(filnm2,'w');
numcom=fgetl(fid);
for i=1:eval(numcom);
  dum=fgetl(fid);
end;
% get axes definition.  X=t2=f2, Y=t1=f1
t2size=fscanf(fid,'%d');
t2label=fscanf(fid,'%c',[1 30]);
t2label=deblank(t2label);
size(t2label);
t1size=fscanf(fid,'%d');
t1label=fscanf(fid,'%c',[1 30]);
t1label=deblank(t1label);
axes=fscanf(fid,'%10f',6);   % f2 from, f2 step, f1 from ,f1 step, min, max
nax=axes;
nax(1)=nax(1)-nax(2);
nax(3)=nax(3)-nax(4);
dat=fscanf(fid,'%10f',Inf);
dat=reshape(dat,t2size(1),t1size(1));
sz=size(dat);
mx=max(max(dat));
%
% create and write the new data set
%
dat2=randfac*mx.*rand(size(1:1:(sz(1)+2)*(sz(2)+2)));
dat2=reshape(dat2,t2size(1)+2,t1size(1)+2);

for i=1:sz(1);
  for j=1:sz(2);
    dat2(i+1,j+1)=dat2(i+1,j+1)+dat(i,j);
  end;
end;
m=max(dat2);
nax(6)=max(m);
%
% Output the new data set
%
fprintf(fid2,'%10d\n',0);
t2size
t1size
fprintf(fid2,'%10d%10d%10d     f2 (MHz)                      \n',t2size(1)+2,1,t2size(3)+2);
fprintf(fid2,'%10d%10d%10d     f2 (MHz)                      \n',t1size(1)+2,1,t1size(3)+2);
fprintf(fid2,'%10.3e%10.3e%10.3e%10.3e%10.3e%10.3e\n',nax);
fprintf(fid2,'%10.3e%10.3e%10.3e%10.3e%10.3e%10.3e%10.3e%10.3e\n',dat2);
fclose('all')

