function m=stap(filnm)
%
% stap('filename') does a stack plot of the data.  Use print -dps filename
% to generate a postscript file.  
%
% Useful things that can be done with the plot:  
%
% axis([xmin xmax ymin ymax zmin zmax])	% plot selected area
% set(gca,'fontsize',[12]); title('PDT in Decane'); % add title at selected
%	fontsize.
% view(azimuth, elevation;	% select different viewpoint -135,20 etc.
%
%
fid=fopen(filnm);
if fid == (-1)   ;                      % does file exist?
    error(['stap: Could not open file filename check path and exist? ']);
end;
numcom=fgetl(fid);
for i=1:eval(numcom);
  dum=fgetl(fid);
end;
% get axes definition.  X=t2=f2, Y=t1=f1
t2size=fscanf(fid,'%d');
t2label=fscanf(fid,'%c',[1 30]);
t2label=deblank(t2label);
size(t2label);
t1size=fscanf(fid,'%d');
t1label=fscanf(fid,'%c',[1 30]);
t1label=deblank(t1label);
axes=fscanf(fid,'%10f',6);
%axis([-75 50 -50 75 0 5000])
dat=fscanf(fid,'%10f',Inf);
dat=reshape(dat,t2size(1),t1size(1));
x=axes(1):axes(2):axes(1)+axes(2)*(t2size-0.5);
y=axes(3):axes(4):axes(3)+axes(4)*(t1size-0.5);
[X,Y]=meshgrid(x,y);
size(X);
size(Y);
size(dat);
mesh(X,Y,dat');
set(gca,'xlabel',text(0,0,t2label,'fontsize',[12]));
set(gca,'ylabel',text(0,0,t1label,'fontsize',[12]));
set(gca,'Zlabel',text(0,0,'Magnitude (Arb.) ','fontsize',[12]));
set(gca,'fontsize',[12]);	% This affects the title font size
title(filnm);
set(gca,'fontsize',[12]);	% This affects the graph axes only
