/* **********************************************************************
 * file catch.c
 *
 ***********************************************************************/

#include <signal.h>
#include <stdio.h>

static long int *ctrlc_flag = NULL;
struct sigaction ctrlc_action;
void *OAction = NULL;


/***********************************************************************
 *
 *   ctrlc_handler: simple handler for receiving SIGINT signal
 *
 ***********************************************************************/
void ctrlc_handler( )

{
  printf("\nUser interrupt pending...\n");
  fflush( stdout );
 *ctrlc_flag = 1;
}



/* **********************************************************************
 *    subroutine catchc
 *
 *       Installs a control-C handler that sets iflag non-zero
 *       when CTRL-C is typed
 * 
 *       Calling sequence:   call catchc( iflag )
 *
 ***********************************************************************/

void catchc( long int *flag )
{
sigset_t dummy;
  if (!ctrlc_flag) {
    ctrlc_flag = flag;
    *ctrlc_flag = 0;
    ctrlc_action.sa_handler = ctrlc_handler;
    ctrlc_action.sa_mask = dummy;
    ctrlc_action.sa_flags = 0;
    sigaction( SIGINT, &ctrlc_action, OAction );
  }
}

/* **********************************************************************
 *
 * subroutine uncatchc( iflag )
 *
 *    Restores default action for handling SIGINT signal
 *
 ********************************************************************** */
void uncatchc( long int *flag )
{
  if (flag == ctrlc_flag) {
	*ctrlc_flag = 0;
	ctrlc_flag = NULL;
	sigaction( SIGINT, SIG_DFL, OAction );
  }
}

