c  VERSION 1.0  (NLSP version)   4/26/93
c----------------------------------------------------------------------
c                    =========================
c                      subroutine LETC
c                    =========================
c
c let <name> {, <name>,...} = <value> {, <value> ... }
c
c      name    : name of the parameter to be assigned a value
c      value   : value to be assigned to the given parameter
c      
c   Up to 10 variables may be assigned values in a single let command
c
c----------------------------------------------------------------------
      subroutine letc(line)
      implicit none
      character*80 line
c
      include 'nlsdim.inc'
      include 'eprprm.inc'
      include 'expdat.inc'
      include 'parcom.inc'
      include 'lpnam.inc'
      include 'stdio.inc'
c
      integer mxlft
      parameter (mxlft=10)
c
      integer ileft,irt,ival,ixf,ixr,ixs,ixri,ixt,lth,left(mxlft)
      double precision fval
      character token*30,prmID*6
      logical rhs,logflg,serprm
c
      integer ipfind,isfind
      logical ftoken,itoken,tcheck
      external ftoken,itoken,tcheck,ipfind,isfind
c
c######################################################################
c
      rhs=.false.
      logflg=.false.
      ileft=1
c
c----------------------------------------------------------------------
c Get the next parameter name (or value for right-hand-side of statement)
c----------------------------------------------------------------------
 1    call gettkn(line,token,lth)
      lth=min(lth,6)
      call touppr(token,lth)
c
c----------------------------------------------------------------------
c  No more tokens: check for error conditions
c----------------------------------------------------------------------
      if (lth.eq.0) then
         if (rhs) then
c                                *** not enough values
            write (luttyo,1000)
         else
            if (ileft.eq.1) then
c                                *** variable name expected
               write (luttyo,1001)
            else
c                                *** no '=' given
               write(luttyo,1002)
            end if
         end if
         return
      end if
c
      if (token.eq.')' .or. (logflg.and.token.eq.'(')) goto 1
c
      if (token.eq.'LOG'.and.rhs) then
         logflg=.true.
         go to 1
      end if
c
c----------------------------------------------------------------------
c  Check for series variables specified
c----------------------------------------------------------------------
      serprm = (token(:lth).eq.'IEXP').or.(token(:lth).eq.'ICOMB')
     #    .or.(token(:lth).eq.'NPT1').or.(token(:lth).eq.'NPT2')
     #    .or.(token(:lth).eq.'INIT1').or.(token(:lth).eq.'INIT2')
     #    .or.(token(:lth).eq.'STEPT1').or.(token(:lth).eq.'STEPT2')
     #    .or.(token(:lth).eq.'TFIX')
c
      if (serprm) then
         write (luttyo,1012) token(:lth)
         call ungett(token,lth,line)
         call series(line)
         return
      end if
c
c----------------------------------------------------------------------
c  Check for '=' sign in assignment
c----------------------------------------------------------------------
      if (token.eq.'=') then
         rhs=.true.
         irt=1
         go to 1
      end if
c
c----------------------------------------------------------------------
c  Right-hand side: assign value to parameter specified in left array
c----------------------------------------------------------------------
      if (rhs) then
         ixr=left(irt)
         irt=irt+1
c
         if (ixr.ne.0) then
c
c   --- EPR parameter floating point assignment
c
            if (ixr.lt.100) then
               if (ixr.lt.-100) then
                  prmID=alias2(-99-(IGXX+ixr))
               else if (ixr.lt.0) then
                  prmID=alias1(1-(IGXX+ixr))
               else
                  prmID=parnam(ixr)
               end if
c
               if (ftoken(token,lth,fval)) then
c
                  if (logflg) then
                     if (fval.gt.0.0d0) then
                        fval=dlog10(fval)
                     else
                        write(luttyo,1011) fval
                     end if
                     logflg=.false.
                  end if
c
                  if (tcheck(ixr,prmID,luttyo))
     #                      fparm(abs(mod(ixr,100)))=fval
c
c                             *** expecting floating point value
               else
                  write(luttyo,1004) token(:lth)
               end if
c
c  --- EPR parameter integer assignment 
c
            else if (ixr.gt.100) then
               ixs=isfind(token,lth)
c                                             *** symbolic value
               if (ixs.gt.0) then
                  iparm(ixr-100)=symval(ixs)
c
c                                             *** integer value
               else if (itoken(token,lth,ival)) then
                  iparm(ixr-100)=ival
c
c                           *** expecting integer value
               else
                  write(luttyo,1005) token(:lth)
               end if
            end if
c
         end if
c
c    --- Return if all assignments have been made
c
         if (irt.ge.ileft) return
c
c----------------------------------------------------------------------
c  Left-hand side: build a list of indices of parameters to be assigned
c----------------------------------------------------------------------
c
       else if (ileft.le.mxlft) then
          left(ileft)=ipfind(token,lth)
          if (left(ileft).eq.0) write (luttyo,1003) token(:lth)
          ileft=ileft+1
       end if
       go to 1
c
c ###### format statements ########################################
c
 1000 format('*** not enough values ***')
 1001 format('*** variable name expected ***')
 1002 format('*** no ''='' specified ***')
 1003 format('*** ''',a,''' is not a parameter ***')
 1004 format('*** Real value expected: ''',a,''' ***')
 1005 format('*** Integer value expected: ''',a,''' ***')
 1011 format(' *** Illegal log argument:',g12.5,' ***')
 1012 format(' *** Series parameters in let command : series ',
     #       'assumed ***')
      end
