c  VERSION 1.0  (NLSP version)   4/26/93
c----------------------------------------------------------------------
c                    =========================
c                       subroutine RMVPRM
c                    =========================
c
c Remove a parameter from the list of parameters being varied for nonlinear
c least-squares. Also maintain the lists of 
c    (1) ibnd    : boundary flag for variable parameter
c    (2) prmin   : minimum for variable parameter
c    (3) prmax   : maximum for variable parameter
c    (4) prscl   : desired accuracy for given parameter
c    (5) xfdstp  : Size of forward-differences step
c    (6) tag     : Name of the parameter (character*6)
c    (7) ixx     : index of each element in the fparm array into the x vector
c
c Includes:
c
c      nlsdim.inc
c      parcom.inc
c      eprprm.inc
c      stdio.inc
c
c----------------------------------------------------------------------
      subroutine rmvprm(ix,ident)
      implicit none
      integer ix
      character ident*6
c
      include 'nlsdim.inc'
      include 'parcom.inc'
      include 'eprprm.inc'
      include 'stdio.inc'
c
      integer i,ixa,j,j1
c
      logical tcheck
      external tcheck
c
c######################################################################
c
      ixa=abs(mod(ix,100)) 
      if (nprm.eq.0) go to 10
c
c----------------------------------------------------------------------
c Loop through the list of parameters being varied (it's in sort order)
c----------------------------------------------------------------------
      do 2 i=1,nprm
         if (ixpr(i).gt.ixa) go to 10
         if (ixpr(i).eq.ixa) then
c
c------------------------------------------------------------------------
c  Parameter found: first, make sure it matches the specified symmetry.
c  If it does, delete it and move up elements below it in the list.
c  (Note that move loop will not execute if we are removing last element;
c  i.e. if i=nprm)
c------------------------------------------------------------------------
            if (.not.tcheck(ix,ident,0) ) go to 10
            ixx(ixpr(i))=0
c
            do 1 j=i,nprm-1
               j1=j+1
               ixpr(j)=ixpr(j1)
               prmin(j)=prmin(j1)
               prmax(j)=prmax(j1)
               prscl(j)=prscl(j1)
               xfdstp(j)=xfdstp(j1)
               ibnd(j)=ibnd(j1)
               tag(j)=tag(j1) 
               ixx(ixpr(j))=ixx(ixpr(j))-1
 1          continue
c
            nprm=nprm-1
            write (luttyo,1001) ident,nprm
            return
         end if
c
 2    continue
c
 10   write (luttyo,1000) ident
      return
c
c #### format statements ###########################################
c
 1000 format('*** Parameter ''',a,''' is not being varied ***')
 1001 format('*** Parameter ''',a,''' fixed: ',
     #i3,' variable parameters ***')
      end
