c*********************************************************************
c
c                       ================
c                       PROGRAM : TSTJAC
c                       ================
c
c       This program calculates the jacobian and its norm.
c
c*********************************************************************
c
      program tstjac
c
      implicit none
c
      include 'stdio.inc'
c
      logical fexist
      character name1*30,name2*30,namej*30
c
      integer i,j,npt1,npt2,ndata,lth
      double precision inif1,res1,inif2,res2,fnorm,fdstep,amin,amax
c
      double precision spec(128,128),spec1(128,128),spec2(128,128)
c
      double precision enorm
      external enorm
c   
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010) 
c
 15   write (luttyo,1020)
      read (luttyi,1025,err=15) name1
 25   write (luttyo,1030)
      read (luttyi,1025,err=25) name2
      write (luttyo,1040)
      read (luttyi,*) fdstep
c
      inquire(file=name1,exist=fexist)
      if (fexist) then
c
         open (unit=ludisk,file=name1,status='old',
     #        access='sequential',form='formatted')
         read (ludisk,*)
         read (ludisk,2110) npt2
         read (ludisk,2110) npt1
         read (ludisk,2120) inif2,res2,inif1,res1,amin,amax
         read (ludisk,2130) ((spec1(i,j),j=1,npt2),i=1,npt1)
         close (unit=ludisk)
      else
         write (luttyo,1050)
         call exit
      end if
c
      inquire(file=name2,exist=fexist)
      if (fexist) then
c
         open (unit=ludisk,file=name2,status='old',
     #        access='sequential',form='formatted')
         read (ludisk,*)
         read (ludisk,2110) npt2
         read (ludisk,2110) npt1
         read (ludisk,2120) inif2,res2,inif1,res1,amin,amax
         read (ludisk,2130) ((spec2(i,j),j=1,npt2),i=1,npt1)
         close (unit=ludisk)
      else
         write (luttyo,1050)
         call exit
      end if
c
c-----------------------------------------------------------------------
c     Calculate Jacobian
c-----------------------------------------------------------------------
c
      do 100 j=1,npt2
      do 100 i=1,npt1
  100    spec(i,j)=(spec1(i,j)-spec2(i,j))/fdstep
c
c  write Jacobian
c
      namej='jacobi.out'
      lth=10
      call wrfit(spec,npt1,npt2,inif2,res2,inif1,res1,amin,amax,
     #           namej,lth)

      ndata=npt1*npt2
c
c     call enorm to get Euclidian norm
c
      fnorm=enorm(ndata,spec)
c
      write (luttyo,1100) fnorm
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(//,2x,70('#'),//)
 1010 format(25x,'PROGRAM : TSTJAC',/,25x,'---------------',//)
 1020 format(2x,'Enter filename-in-full for f(x+dx) : ')
 1025 format(a)
 1030 format(2x,'Enter filename-in-full for f(x) : ')
 1040 format(2x,'Enter fdstep : ')
 1050 format(2x,'** No such file **')
c
 1100 format(2x,'fnorm = ',g14.7)
c
 2110 format(i10)
 2120 format(6e10.4)
 2130 format(5e14.7)
c
c=====================================================================
c
      end
